%bcond_with bootstrap
%global artifact_name io.takari.incrementalbuild

Name:           takari-incrementalbuild
Version:        0.20.7
Release:        5%{?dist}
Summary:        Takari Incremental Build
License:        EPL-1.0
URL:            http://takari.io
BuildArch:      noarch

# Upstream Eclipse no longer supports non-64bit arches
ExcludeArch: s390 %{arm} %{ix86}

Source0:        https://github.com/takari/%{artifact_name}/archive/%{artifact_name}-%{version}.tar.gz
Source1:        http://www.eclipse.org/legal/epl-v10.html

BuildRequires:  maven-local
BuildRequires:  mvn(com.google.inject:guice::no_aop:)
BuildRequires:  mvn(com.squareup:javapoet)
BuildRequires:  mvn(javax.enterprise:cdi-api)
BuildRequires:  mvn(javax.inject:javax.inject)
BuildRequires:  mvn(junit:junit)
BuildRequires:  mvn(org.apache.felix:maven-bundle-plugin)
BuildRequires:  mvn(org.apache.maven:maven-artifact)
BuildRequires:  mvn(org.apache.maven:maven-core)
BuildRequires:  mvn(org.apache.maven:maven-model)
BuildRequires:  mvn(org.apache.maven:maven-plugin-api)
BuildRequires:  mvn(org.apache.maven.plugin-tools:maven-plugin-annotations)
BuildRequires:  mvn(org.apache.maven.resolver:maven-resolver-api)
BuildRequires:  mvn(org.apache.maven.resolver:maven-resolver-util)
BuildRequires:  mvn(org.codehaus.plexus:plexus-classworlds)
BuildRequires:  mvn(org.codehaus.plexus:plexus-utils)
BuildRequires:  mvn(org.eclipse.sisu:org.eclipse.sisu.plexus)
BuildRequires:  mvn(org.slf4j:slf4j-api)

%if %{without bootstrap}
BuildRequires:  mvn(io.takari.maven.plugins:takari-lifecycle-plugin)
BuildRequires:  mvn(io.takari.maven.plugins:takari-plugin-testing)
BuildRequires:  mvn(io.takari:takari:pom:)
%else
BuildRequires:  mvn(org.eclipse.sisu:sisu-maven-plugin)
%endif

%description
Incremental build support library for Apache Maven.

%package javadoc
Summary:        API documentation for %{name}

%description javadoc
This package provides %{summary}.


%prep
%setup -q -n %{artifact_name}-%{artifact_name}-%{version}

cp -a %{SOURCE1} .

# XXX skip ITs for now
%pom_disable_module incrementalbuild-its
%pom_disable_module takari-builder-demo

# Upstream comments out some modules and relies on older version being pulled
# in from maven central. We need them all at once
for module in takari-builder-security-manager incrementalbuild-workspace; do
    %pom_xpath_inject /pom:project/pom:modules "<module>$module</module>"
    %pom_set_parent io.takari:io.takari.incrementalbuild:%{version} $module
    %pom_change_dep -r :$module ::%{version}
done

%pom_remove_plugin -r :animal-sniffer-maven-plugin

%if %{with bootstrap}
%pom_remove_parent
%pom_add_plugin org.eclipse.sisu:sisu-maven-plugin '
<executions>
  <execution>
    <id>index-project</id>
    <goals>
      <goal>main-index</goal>
    </goals>
  </execution>
</executions>'
%pom_xpath_remove -r 'pom:project/pom:packaging[contains(text(),"takari")]'
%pom_add_plugin :maven-compiler-plugin '
<configuration>
  <source>1.8</source>
  <target>1.8</target>
  <compilerArgument>-proc:none</compilerArgument>
</configuration>'
%pom_remove_dep io.takari.maven.plugins:takari-plugin-testing incrementalbuild
rm -rf incrementalbuild/src/main/java/io/takari/incrementalbuild/maven/testing/IncrementalBuildRule.java
%endif

%build
%mvn_build -f

%install
%mvn_install


%files -f .mfiles
%license epl-v10.html

%files javadoc -f .mfiles-javadoc
%license epl-v10.html

%changelog
* Tue May 07 2019 Mat Booth <mat.booth@redhat.com> - 0.20.7-5
- Restrict to same architectures as Eclipse itself

* Tue Apr 23 2019 Mat Booth <mat.booth@redhat.com> - 0.20.7-4
- Update license tag
- Fix bootstrapping mode

* Sun Feb 03 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.20.7-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Sat Jul 14 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.20.7-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Fri Mar 02 2018 Michael Simacek <msimacek@redhat.com> - 0.20.7-1
- Update to upstream version 0.20.7

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.20.6-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Mon Nov 27 2017 Michael Simacek <msimacek@redhat.com> - 0.20.6-3
- Non-bootstrap build

* Mon Nov 27 2017 Michael Simacek <msimacek@redhat.com> - 0.20.6-2
- Fix missing artifacts

* Sun Oct 22 2017 Michael Simacek <msimacek@redhat.com> - 0.20.6-1
- Update to upstream version 0.20.6

* Wed Sep 20 2017 Michael Simacek <msimacek@redhat.com> - 0.20.5-2
- Disable demo module to fix build

* Mon Aug 14 2017 Michael Simacek <msimacek@redhat.com> - 0.20.5-1
- Update to upstream version 0.20.5

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.20.4-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.20.4-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Mon Feb 15 2016 Michael Simacek <msimacek@redhat.com> - 0.20.4-1
- Non-bootstrap build

* Mon Feb 15 2016 Michael Simacek <msimacek@redhat.com> - 0.20.4-0.1
- Update to upstream version 0.20.4
- Remove upstreamed patch
- Bootstrap build

* Fri Feb 05 2016 Fedora Release Engineering <releng@fedoraproject.org> - 0.20.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Fri Jun 19 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.20.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Wed Apr 22 2015 Mikolaj Izdebski <mizdebsk@redhat.com> - 0.20.1-1
- Update to upstream version 0.20.1

* Tue Mar 17 2015 Michael Simacek <msimacek@redhat.com> - 0.10.0-4
- Build with optional part and tests enabled

* Thu Mar 12 2015 Mikolaj Izdebski <mizdebsk@redhat.com> - 0.10.0-3
- Non-bootstrap bulid

* Fri Mar 06 2015 Michael Simacek <msimacek@redhat.com> - 0.10.0-2
- Working build

* Fri Feb 20 2015 Mikolaj Izdebski <mizdebsk@redhat.com> - 0.10.0-1
- Initial packaging
